Index: /trunk/src/lib/network/synchronizeable_var/synchronizeable_string.cc
===================================================================
--- /trunk/src/lib/network/synchronizeable_var/synchronizeable_string.cc	(revision 7954)
+++ /trunk/src/lib/network/synchronizeable_var/synchronizeable_string.cc	(revision 7954)
@@ -0,0 +1,103 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Christoph Renner
+   co-programmer: ...
+*/
+
+
+#include "synchronizeable_string.h"
+#include "converter.h"
+
+
+/**
+ * standard constructor
+ * @todo this constructor is not jet implemented - do it
+*/
+SynchronizeableString::SynchronizeableString( std::string * ptrIn, std::string * ptrOut, std::string name, int permission, int priority) : SynchronizeableVar( ptrIn, ptrOut, name, 0, permission, priority )
+{
+  this->vPtrIn = ptrIn;
+  this->vPtrOut = ptrOut;
+}
+
+
+/**
+ * standard deconstructor
+*/
+SynchronizeableString::~SynchronizeableString ()
+{
+}
+
+/**
+ * write var data to byte buffer
+ * @param buf pointer to write to
+ * @param maxLength writeToBuf will not write more than maxLength bytes
+ * @return number bytes written
+ */
+int SynchronizeableString::writeToBuf( byte * buf, int maxLength )
+{
+  int res = Converter::stringToByteArray( *vPtrIn, buf, maxLength );
+  
+  assert( res > 0 );
+  
+  return res;
+}
+
+/**
+ * read var data from byte buffer
+ * @param buf pointer to read from
+ * @param maxLength readFromBuf will not read more than maxLength bytes
+ * @return number bytes read
+ */
+int SynchronizeableString::readFromBuf( byte * buf, int maxLength )
+{
+  std::string oldVal = *vPtrOut;
+      
+  int res = Converter::byteArrayToString( buf, *vPtrOut, maxLength );
+  
+  setHasChanged( oldVal != *vPtrOut );
+  
+  if ( res < 0 )
+  {
+    printf("%s | res (%d) < 0\n", this->getName().c_str(), res);
+  }
+  assert( res > 0 );
+  
+  return res;
+}
+
+/**
+ * print out variable value
+ */
+void SynchronizeableString::debug( )
+{
+  printf( "SYNCHRONIZEABLE_VAR: %s IN: '%s' OUT: '%s'\n", name.c_str(), vPtrIn->c_str(), vPtrOut->c_str() );
+}
+
+
+/**
+ * reads actual size from buffer. this is used when size is not constant
+ * @param buf pointer to data
+ * @param maxLength maximal size of data
+ * @return same as readFromBuf would return
+ */
+int SynchronizeableString::getSizeFromBuf( byte * buf, int maxLength )
+{
+  std::string t;
+  
+  int res = Converter::byteArrayToString( buf, t, maxLength );
+  
+  assert( res > 0 );
+  
+  return res;
+}
+
+
Index: /trunk/src/lib/network/synchronizeable_var/synchronizeable_string.h
===================================================================
--- /trunk/src/lib/network/synchronizeable_var/synchronizeable_string.h	(revision 7954)
+++ /trunk/src/lib/network/synchronizeable_var/synchronizeable_string.h	(revision 7954)
@@ -0,0 +1,42 @@
+/*!
+ * @file synchronizeable_string.h
+ * @brief Definition of SynchronizeableString
+*/
+
+#include "synchronizeable_var/synchronizeable_var.h"
+#include "converter.h"
+
+#ifndef _SYNCHRONIZEABLE_STRING_H
+#define _SYNCHRONIZEABLE_STRING_H
+
+#include <string>
+
+class SynchronizeableString : public SynchronizeableVar {
+
+  public:
+    SynchronizeableString( std::string * ptrIn, std::string * ptrOut, std::string name, int permission = PERMISSION_SERVER, int priority = 0 );
+    virtual ~SynchronizeableString();
+    
+    virtual int writeToBuf( byte * buf, int maxLength );
+    virtual int readFromBuf( byte * buf, int maxLength );
+    
+        
+    /**
+     * check if writeToBuf will return the same size every time
+     * @return true if same size every time
+     */
+    virtual bool hasStaticSize(){ return false; };
+    
+    virtual int getSize(){ return vPtrIn->length()+INTSIZE; }
+    
+    virtual int getSizeFromBuf( byte * buf, int maxLength );
+    
+    virtual void debug();
+    
+  private:
+    std::string * vPtrIn;       //!< pointer to data (read)
+    std::string * vPtrOut;      //!< pointer to data (write)
+
+};
+
+#endif /* _SYNCHRONIZEABLE_STRING_H */
Index: /trunk/src/lib/network/synchronizeable_var/synchronizeable_uint.cc
===================================================================
--- /trunk/src/lib/network/synchronizeable_var/synchronizeable_uint.cc	(revision 7954)
+++ /trunk/src/lib/network/synchronizeable_var/synchronizeable_uint.cc	(revision 7954)
@@ -0,0 +1,43 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Christoph Renner
+   co-programmer: ...
+*/
+
+
+#include "synchronizeable_uint.h"
+
+
+/**
+ * standard constructor
+*/
+SynchronizeableUInt::SynchronizeableUInt( unsigned int * ptrIn, unsigned int * ptrOut, std::string name, int permission, int priority) : SynchronizeableInt( (int*)ptrIn, (int*)ptrOut, name, permission, priority )
+{
+}
+
+
+/**
+ * standard deconstructor
+*/
+SynchronizeableUInt::~SynchronizeableUInt ()
+{
+}
+
+
+/**
+ * print out variable value
+ */
+void SynchronizeableUInt::debug( )
+{
+  printf( "SYNCHRONIZEABLE_VAR: %s IN: %u OUT: %u\n", name.c_str(), *vPtrIn, *vPtrOut );
+}
+
Index: /trunk/src/lib/network/synchronizeable_var/synchronizeable_uint.h
===================================================================
--- /trunk/src/lib/network/synchronizeable_var/synchronizeable_uint.h	(revision 7954)
+++ /trunk/src/lib/network/synchronizeable_var/synchronizeable_uint.h	(revision 7954)
@@ -0,0 +1,21 @@
+/*!
+ * @file synchronizeable_uint.h
+ * @brief Definition of SynchronizeableInt
+*/
+
+#include "synchronizeable_var/synchronizeable_int.h"
+
+#ifndef _SYNCHRONIZEABLE_UINT_H
+#define _SYNCHRONIZEABLE_UINT_H
+
+class SynchronizeableUInt : public SynchronizeableInt {
+
+  public:
+    SynchronizeableUInt( unsigned int * ptrIn, unsigned int * ptrOut, std::string name, int permission = PERMISSION_SERVER, int priority = 0 );
+    virtual ~SynchronizeableUInt();
+    
+    virtual void debug();
+
+};
+
+#endif /* _PROTO_CLASS_H */
Index: /trunk/src/lib/network/synchronizeable_var/synchronizeable_var.cc
===================================================================
--- /trunk/src/lib/network/synchronizeable_var/synchronizeable_var.cc	(revision 7954)
+++ /trunk/src/lib/network/synchronizeable_var/synchronizeable_var.cc	(revision 7954)
@@ -0,0 +1,48 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Christoph Renner
+   co-programmer: ...
+*/
+
+
+#include "synchronizeable_var.h"
+
+
+
+/**
+ * standard constructor
+ * @todo this constructor is not jet implemented - do it
+*/
+SynchronizeableVar::SynchronizeableVar ( void * ptrIn, void * ptrOut, std::string name, int length, int permission, int priority)
+{
+  assert( ptrIn );
+  assert( ptrOut );
+
+  this->ptrIn = ptrIn;
+  this->ptrOut = ptrOut;
+  this->length = length;
+  this->permission = permission;
+  this->priority = priority;
+  this->realPriority = priority;
+  this->name = name;
+  this->bWatched = false;
+  this->changed = false;
+}
+
+
+/**
+ * standard deconstructor
+*/
+SynchronizeableVar::~SynchronizeableVar ()
+{
+}
+
Index: /trunk/src/lib/network/synchronizeable_var/synchronizeable_var.h
===================================================================
--- /trunk/src/lib/network/synchronizeable_var/synchronizeable_var.h	(revision 7954)
+++ /trunk/src/lib/network/synchronizeable_var/synchronizeable_var.h	(revision 7954)
@@ -0,0 +1,157 @@
+/*!
+ * @file synchronizeable_var.h
+ * @brief Definition of SynchronizeableVar
+*/
+
+#ifndef _SYNCHRONIZEABLE_VAR_H
+#define _SYNCHRONIZEABLE_VAR_H
+
+#include <string>
+#include "netdefs.h"
+#include <assert.h>
+
+enum {
+  PERMISSION_SERVER = 1,
+  PERMISSION_OWNER  = 2,
+  PERMISSION_ALL    = 4
+};
+
+class SynchronizeableVar {
+
+  public:
+    SynchronizeableVar( void * ptrIn, void * ptrOut, std::string name, int length, int permission = PERMISSION_SERVER, int priority = 0 );
+    virtual ~SynchronizeableVar();
+
+    /**
+     * check if synchronizeable wants to be informed on changes
+     * @return true if synchronizeable wants to be informed on changes
+     */
+    inline bool beWatched(){ return this->bWatched; }
+    
+    /** 
+     * set flag if synchronizeable wants to be informed on changes
+     */
+    inline void setWatched( bool watched ){ this->bWatched = watched; }
+
+    /**
+     * write var data to byte buffer
+     * @param buf pointer to write to
+     * @param maxLength writeToBuf will not write more than maxLength bytes
+     * @return number bytes written
+     */
+    virtual int writeToBuf( byte * buf, int maxLength ) = 0;
+
+    /**
+     * read var data from byte buffer
+     * @param buf pointer to read from
+     * @param maxLength readFromBuf will not read more than maxLength bytes
+     * @return number bytes read
+     */
+    virtual int readFromBuf( byte * buf, int maxLength ) = 0;
+
+    /**
+     * check if writeToBuf will return the same size every time
+     * @return true if same size every time
+     */
+    virtual bool hasStaticSize() = 0;
+
+    /**
+     * get size writeToBuf needs
+     * @return size in bytes
+     */
+    virtual int getSize(){ return length; }
+
+    /**
+     * check for permission to write
+     * @return true if you can write
+     */
+    inline bool checkPermission( int permission ){ return (permission & this->permission) != 0; }
+
+    /**
+     * get variable name
+     * @return name
+     */
+    inline std::string getName(){ return name; }
+
+    /**
+     * set variable name
+     * @param name new name
+     */
+    inline void setName( std::string name ) { this->name = name; }
+
+    /**
+     * get priority
+     * @return priority
+     */
+    inline int getPriority() { return this->priority; }
+
+    /**
+     * set priority
+     * @param p priority
+     */
+    inline void setPriority( int p ) { this->priority = p; }
+
+    /**
+     * reset priority to variable specific default value
+     */
+    inline void resetPriority() { this->priority = this->realPriority; }
+    
+    /**
+     * reads actual size from buffer. this is used when size is not constant
+     * @param buf pointer to data
+     * @param maxLength maximal size of data
+     * @return same as readFromBuf would return
+     */
+    virtual inline int getSizeFromBuf( byte * buf, int maxLength ){ return this->getSize(); }
+    
+    /**
+     * set variable id
+     * @param id
+     */
+    inline void setVarId( int id ){ this->varId = id; }
+    
+    /** 
+     * get variable id
+     * @return variable id
+     */
+    inline int getVarId(){ return varId; }
+    
+    /**
+     * set hasChanged
+     * @param changed
+     */
+    inline void setHasChanged( bool changed ){ this->changed = changed; }
+    
+    /** 
+     * get hasChanged
+     * @return variable id
+     */
+    inline bool getHasChanged(){ return changed; }
+    
+    /**
+     * print out variable value
+     */
+    virtual void debug() = 0;
+
+
+  private:
+    bool bWatched;      //!< true if synchronizeable wants to be informed on changes
+    
+    int permission;     //!< who is allowed to change this var
+    int priority;       //!< priority assigned to var
+    int realPriority;   //!< priority assigned to var, increased every time not sent
+    int varId;          //!< id to identify varables
+    
+    bool changed;       //!< true if last readFromBuf changed anything
+
+  protected:
+    void * ptrIn;       //!< pointer to data (read)
+    void * ptrOut;      //!< pointer to data (write)
+    int length;         //!< data length
+
+
+    std::string name;    //!< variable name (for debugging)
+
+};
+
+#endif /* _PROTO_CLASS_H */
Index: /trunk/src/lib/network/synchronizeable_var/synchronizeable_vector.cc
===================================================================
--- /trunk/src/lib/network/synchronizeable_var/synchronizeable_vector.cc	(revision 7954)
+++ /trunk/src/lib/network/synchronizeable_var/synchronizeable_vector.cc	(revision 7954)
@@ -0,0 +1,112 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Christoph Renner
+   co-programmer: ...
+*/
+
+
+#include "synchronizeable_vector.h"
+#include "converter.h"
+
+
+/**
+ * standard constructor
+ * @todo this constructor is not jet implemented - do it
+*/
+SynchronizeableVector::SynchronizeableVector( Vector * ptrIn, Vector * ptrOut, std::string name, int permission, int priority) : SynchronizeableVar( ptrIn, ptrOut, name, 3*FLOATSIZE, permission, priority )
+{
+  this->vPtrIn = ptrIn;
+  this->vPtrOut = ptrOut;
+}
+
+
+/**
+ * standard deconstructor
+*/
+SynchronizeableVector::~SynchronizeableVector ()
+{
+}
+
+/**
+ * write var data to byte buffer
+ * @param buf pointer to write to
+ * @param maxLength writeToBuf will not write more than maxLength bytes
+ * @return number bytes written
+ */
+int SynchronizeableVector::writeToBuf( byte * buf, int maxLength )
+{
+  int n = 0;
+  int res;
+
+  res = Converter::floatToByteArray( vPtrIn->x, buf + n, maxLength - n );
+  assert( res > 0 );
+  n += res;
+
+  res = Converter::floatToByteArray( vPtrIn->y, buf + n, maxLength - n );
+  assert( res > 0 );
+  n += res;
+
+  res = Converter::floatToByteArray( vPtrIn->z, buf + n, maxLength - n );
+  assert( res > 0 );
+  n += res;
+
+  assert( 3*FLOATSIZE == n );
+
+  return n;
+}
+
+/**
+ * read var data from byte buffer
+ * @param buf pointer to read from
+ * @param maxLength readFromBuf will not read more than maxLength bytes
+ * @return number bytes read
+ */
+int SynchronizeableVector::readFromBuf( byte * buf, int maxLength )
+{
+  assert( maxLength >= 3*FLOATSIZE );
+
+  float x,y,z;
+
+  int res;
+  int n = 0;
+  
+  Vector oldVec = *vPtrOut;
+
+  res = Converter::byteArrayToFloat( buf + n, &x );
+  assert( res > 0 );
+  n += res;
+
+  res = Converter::byteArrayToFloat( buf + n, &y );
+  assert( res > 0 );
+  n += res;
+
+  res = Converter::byteArrayToFloat( buf + n, &z );
+  assert( res > 0 );
+  n += res;
+
+  *vPtrOut = Vector( x, y, z );
+  
+  setHasChanged( !(*vPtrOut == oldVec) );
+
+  assert( n == 3*FLOATSIZE );
+  return n;
+}
+
+
+/**
+ * print out variable value
+ */
+void SynchronizeableVector::SynchronizeableVector::debug( )
+{
+  printf( "SYNCHRONIZEABLE_VAR: %s IN: (%f, %f, %f) OUT: (%f %f %f)\n", name.c_str(), vPtrIn->x, vPtrIn->y, vPtrIn->z, vPtrOut->x, vPtrOut->y, vPtrOut->z );
+}
+
Index: /trunk/src/lib/network/synchronizeable_var/synchronizeable_vector.h
===================================================================
--- /trunk/src/lib/network/synchronizeable_var/synchronizeable_vector.h	(revision 7954)
+++ /trunk/src/lib/network/synchronizeable_var/synchronizeable_vector.h	(revision 7954)
@@ -0,0 +1,36 @@
+/*!
+ * @file synchronizeable_vector.h
+ * @brief Definition of SynchronizeableVector
+*/
+
+#include "synchronizeable_var/synchronizeable_var.h"
+
+#ifndef _SYNCHRONIZEABLE_VECTOR_H
+#define _SYNCHRONIZEABLE_VECTOR_H
+
+#include "vector.h"
+
+class SynchronizeableVector : public SynchronizeableVar {
+
+  public:
+    SynchronizeableVector( Vector * ptrIn, Vector * ptrOut, std::string name, int permission = PERMISSION_SERVER, int priority = 0 );
+    virtual ~SynchronizeableVector();
+    
+    virtual int writeToBuf( byte * buf, int maxLength );
+    virtual int readFromBuf( byte * buf, int maxLength );
+    
+    /**
+     * check if writeToBuf will return the same size every time
+     * @return true if same size every time
+     */
+    virtual bool hasStaticSize(){ return true; }
+    
+    virtual void debug();
+    
+  private:
+    Vector * vPtrIn;       //!< pointer to data (read)
+    Vector * vPtrOut;      //!< pointer to data (write)
+
+};
+
+#endif /* _PROTO_CLASS_H */
Index: /trunk/src/lib/network/tcp_server_socket.cc
===================================================================
--- /trunk/src/lib/network/tcp_server_socket.cc	(revision 7954)
+++ /trunk/src/lib/network/tcp_server_socket.cc	(revision 7954)
@@ -0,0 +1,137 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Christoph Renner
+   co-programmer:
+*/
+
+/* this is for debug output. It just says, that all calls to PRINT() belong to the DEBUG_MODULE_NETWORK module
+   For more information refere to https://www.orxonox.net/cgi-bin/trac.cgi/wiki/DebugOutput
+*/
+#define DEBUG_MODULE_NETWORK
+
+#include "tcp_server_socket.h"
+#include "tcp_socket.h"
+
+
+/* header for debug output */
+#include "debug.h"
+
+TcpServerSocket::TcpServerSocket( int port ) : ServerSocket( port )
+{
+  init();
+  listen(port);
+}
+
+/**
+ * Default destructor
+ */
+TcpServerSocket::~TcpServerSocket( )
+{
+  /* Quit SDL_net */
+  // NOTE: what if other instances of NetworkSocket running?
+  SDLNet_Quit();
+  PRINTF(5)("SDL_net shutdown\n");
+
+  _isListening = false;
+}
+
+void TcpServerSocket::init( )
+{
+  /* set the class id for the base object */
+  this->setClassID(CL_SERVER_SOCKET, "TcpServerSocket");
+
+  terminateThread = false;
+  listenSocket = NULL;
+  _isListening = false;
+
+  if(SDLNet_Init()==-1)
+  {
+    PRINTF(1)("SDLNet_Init: %s\n", SDLNet_GetError());
+    return;
+  }
+  else
+    PRINTF(5)("SDL_net initialized\n");
+
+  PRINTF(0)("TcpServerSocket created\n");
+}
+
+
+/**
+ * Tells the NetworkSocket to listen on a specific port for incoming connections.
+ * NetworkSocket::writeBytes(...) will have no effect until there is a valuable connection.
+ * @param port
+ */
+bool TcpServerSocket::listen(unsigned int port)
+{
+  PRINTF(0)("TcpServerSocket::listen()\n");
+  _isListening = true;
+  //check if not already connected or listening
+  if (listenSocket)
+  {
+    PRINTF(1)("TcpServerSocket::listen: tcpSocket!=NULL! maybe you already called listen or did not call close()!\n");
+    _isListening = false;
+    return false;
+  }
+
+  IPaddress ip;
+
+  if (SDLNet_ResolveHost(&ip, NULL, port)==-1)
+  {
+    PRINTF(1)("SDLNet_ResolveHost: %s\n", SDLNet_GetError());
+    _isListening = false;
+    return false;
+  }
+
+  listenSocket = SDLNet_TCP_Open(&ip);
+
+  if (!listenSocket)
+  {
+    PRINTF(1)("SDLNet_TCP_Open: %s\n", SDLNet_GetError());
+    _isListening = false;
+    return false;
+  }
+
+  return true;
+}
+
+
+NetworkSocket* TcpServerSocket::getNewSocket( )
+{
+  if ( !listenSocket )
+  {
+    PRINTF(1)("listenSocket == NULL! Maybe you forgot to call listen()\n");
+    close();
+    return NULL;
+  }
+
+  TCPsocket sock = SDLNet_TCP_Accept(listenSocket);
+
+  if ( !sock )
+  {
+    return NULL;
+  }
+  else
+  {
+    return new TcpSocket(sock);
+  }
+}
+
+void TcpServerSocket::close( )
+{
+  if ( listenSocket )
+  {
+    SDLNet_TCP_Close( listenSocket );
+    listenSocket = NULL;
+  }
+
+  _isListening = false;
+}
Index: /trunk/src/lib/network/tcp_server_socket.h
===================================================================
--- /trunk/src/lib/network/tcp_server_socket.h	(revision 7954)
+++ /trunk/src/lib/network/tcp_server_socket.h	(revision 7954)
@@ -0,0 +1,41 @@
+/*!
+ * @file server_socket.h
+ *  waits for incoming connections
+
+ */
+
+#ifndef _TCP_SERVER_SOCKET
+#define _TCP_SERVER_SOCKET
+
+/* include this file, it contains some default definitions */
+#include "netdefs.h"
+
+
+/* include base_object.h since all classes are derived from this one */
+#include "base_object.h"
+#include "server_socket.h"
+
+
+class TcpServerSocket : public ServerSocket
+{
+  public:
+    TcpServerSocket( int port );
+
+    virtual ~TcpServerSocket();
+
+    virtual bool listen( unsigned int port );
+    virtual NetworkSocket* getNewSocket( void );
+    virtual void close();
+    virtual void update() {};
+    
+  private:
+    TCPsocket listenSocket;
+    bool terminateThread;
+
+    bool _isListening;
+
+    void init();
+ 
+};
+
+#endif
